<template>
  <div style="height: 100%">
    <slot
      :source="scaledSource"
    />
  </div>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, Watch,
} from 'vue-property-decorator';
import type { Source } from '@/data';

@Component
export default class SourceScaler extends Vue {
  @Prop({ required: true })
  source!: Source;

  @Prop({ default: 1 })
  scale!: number;

  scaledSource: Source | null = null;

  created() {
    this.updateScale();
  }

  @Watch('source', { deep: true })
  @Watch('scale')
  updateScale() {
    if (this.scale === 1) {
      this.scaledSource = this.source;
    } else {
      this.scaledSource = this.source.scaled(this.scale);
    }
  }
}
</script>
